<template>
	<div class="cartStyle" v-if="!isloading" :style="{ height: contentHeight }">
		<view
			style="
        display: flex;
        flex-direction: row;
        align-items: center;
        justify-content: space-between;
        padding: 0 15rpx;
      "
		>
			<Text class="grid-text">商品库存有限，请尽快下单哦</Text>
			<Text @click="edit" v-if="editType == false && list[0].GoodsList.length>0" class="grid-text_r">编辑</Text>
			<Text @click="edit" v-if="editType == true" class="grid-text_r">完成</Text>
		</view>
		<view style="width: 100%; height: 30rpx; background: #f7f7f7; margin: 20rpx 0;"></view>
		<u-empty v-if="list.length == 0" text="购物车还是空的哦" mode="car"></u-empty>

		<view
			v-if="list.length > 0"
			style="
        height: calc(100vh - 60px);
        width: calc(100vw);
        overflow: hidden;
        padding-top: 10px;
      "
		>
			<scroll-view :scroll-y="true" :enable-back-to-top="true" :enable-flex="true" :style="{ height: '100%' }">
				<template v-if="list.length > 0">
					<view class="cartList" :style="{ 'margin-bottom': listbottom }" v-for="(c, i) in list" :key="i">
						<view
							style="
                padding: 0 12px 12px 12px;
                border-bottom: 1rpx solid #f5f5f5;
                width: 100%;
              "
						>
							<u-checkbox-group @change="mch_SelectAll(c.checked, i)">
								<u-checkbox v-model="c.checked" shape="circle" :active-color="mc">{{ c.MallName }}</u-checkbox>
							</u-checkbox-group>
						</view>
						<view class="cartList_item" v-for="(item, index) in c.GoodsList" :key="index" :name="item.GoodsName">
							<view style="width: 40px;text-align: center;" v-if="item.GoodsStatus == 1 || editType == true">
								<u-checkbox-group @change="clickcheckbox(item.checked, item.Price, index, i)">
									<u-checkbox v-model="item.checked" shape="circle" :active-color="mc"></u-checkbox>
								</u-checkbox-group>
							</view>

							<view class="invalid" :style="{ background: mc }" v-if="item.GoodsStatus != 1 && editType == false">
								<Text style="color: #fff; width: 22px;font-size: 20rpx;">失效</Text>
							</view>

							<image
								:src="item.CoverImage"
								mode="aspectFill"
								style="
                  width: 150rpx;
                  height: 150rpx;
                  margin-left: 30rpx;
                  border-radius: 5px;
                "
								@click="clickHandler(item.GoodsId)"
							/>
							<view
								style="
                  display: flex;
                  flex-direction: column;
                  justify-content: space-between;
                  width: 440rpx;
                  height: 150rpx;
                  margin-left: 20rpx;
                "
							>
								<Text
									style="
                    font-size: 28rpx;
                    width: 440rpx;
                    overflow: hidden;
                    white-space: nowrap;
                    text-overflow: ellipsis;
                  "
								>
									{{ item.GoodsName}}
								</Text>
								<view
									style="
                    width: 440rpx;
                    overflow: hidden;
                    white-space: nowrap;
                    text-overflow: ellipsis;
                  "
								>
									<view v-for="(attr, inde2x) in item.SpecificationList" :key="inde2x">
										<Text
											style="
                        color: #a0a09d;
                        font-size: 24rpx;
                        margin-right: 5rpx;
                      "
										>
											{{ attr}}
										</Text>
									</view>
								</view>
								<view
									style="
                    display: flex;
                    flex-direction: row;
                    align-items: center;
                    justify-content: space-between;
                  "
								>
									<Text style="font-size: 30rpx;" :style="{ color: mc }">
										￥
										<Text style="40rpx">{{ item.Price }}</Text>
									</Text>
									<u-number-box
										v-model="item.Number"
										:min="1"
										:max="item.InventoryNum"
										@change="valChange(i, index, item.Number, item.Price, $event)"
									></u-number-box>
								</view>
								<Text v-if="item.GoodsStatus != 1 && editType == false" style="font-size: 20rpx;color:#a0a09d ;">失效原因：商品下架或者库存不足</Text>
							</view>
						</view>
					</view>
				</template>
			</scroll-view>
		</view>

		<view class="box_bottom">
			<div style="margin-left: 30rpx;">
				<u-checkbox-group @change="SelectAll">
					<u-checkbox v-model="allchecked" shape="circle" :active-color="mc">全选</u-checkbox>
				</u-checkbox-group>
				<Text style="font-size: 30rpx;" :style="{ color: mc }" v-if="editType == false">￥{{ TotalPrice }}</Text>
			</div>
			<div class="bottom_btn" v-if="!editType">
				<u-button
					size="80"
					:ripple="true"
					shape="circle"
					@click="settlement"
					:custom-style="{
						backgroundColor: mc,
						height: '80rpx',
						color: '#FFF',
						fontSize: '14px'
					}"
				>
					去结算({{ checkCount }})
				</u-button>
			</div>
			<u-button
				v-if="editType"
				size="80"
				:ripple="true"
				shape="circle"
				@click="delete_btn"
				:custom-style="{
					backgroundColor: secondary,
					height: '80rpx',
					color: '#FFF',
					fontSize: '14px',
					marginRight: '12px'
				}"
			>
				删除
			</u-button>
		</view>

		<tabbars></tabbars>
		<auth v-if="showAuth" @changeuserinfo="reloadUserinfo" @gbAuth="gbAuth"></auth>
	</div>
</template>
<script>
import tabbars from '@/components/tabbar/index';
import auth from "@/components/auth/index.vue";

export default {
	data() {
		return {
			isloading: false,
			pageTitle: '购物车',
			navHeight: 0,
			contentHeight: 0,
			cstyle: {},

			allchecked: false,
			TotalPrice: 0, //总价格
			bottommargin: 0,
			listbottom: 0,
			editType: false,
			list: [],

			cart_id_list: [],
			mc: '',
			secondary: '',
			checkCount: 0,
			msg: {
				pageIndex: 1,
				pageSize: 50,
				Name: ''
			},
			showAuth:false
		};
	},
	created() {},
	components: {
		tabbars,
		auth
	},
	onLoad() {
		this.navHeight = this.$navHeight - 2;
		this.mc = this.$uiConfig.mainColor;
		this.secondary = this.$uiConfig.secondary;
		this.cstyle = uni.getStorageSync('basedata') ? uni.getStorageSync('basedata').cat_style : [];

		if (this.cstyle.cat_style == '4') {
		}
	},
	onShow(){
		
	},
	mounted() {
		let currentPages = getCurrentPages();
		let c = this.$uiConfig.is_bang ? 80 : 52;
		this.bottommargin = c - 2 + 'px';
		this.listbottom = c + 44 + 'px';
		this.contentHeight = this.$utils.calcContentHeight(c - 42) + 'px';
		let u = '/' + currentPages[currentPages.length - 1].route;
		let pages = wx.getStorageSync('basedata') ? wx.getStorageSync('basedata').bar_title : [];
		pages.forEach(x => {
			if (x.value == u) {
				this.pageTitle = x.new_name ? x.new_name : x.name;
			}
		});
		uni.setNavigationBarTitle({
			title: this.pageTitle
		});
		this.u = uni.getStorageSync('mall_UserInfo');
		if (!this.u) {
			this.u = {
				nickName: '未登录',
				avatarUrl: ''
			};
			this.showAuth = true;
		}else{
			this.init();
		}
		
	},
	methods: {
		reloadUserinfo() {
			this.u = uni.getStorageSync('mall_UserInfo');
			this.showAuth = false;
			this.init()
		},
		//关闭登录窗口
		gbAuth(){
			this.showAuth=false;
		},
		goHome() {
			uni.redirectTo({
				url: '/pages/index/main'
			});
		},
		init() {
			uni.showNavigationBarLoading();
			let h = this.apiheader();
			this.isloading=true;
			this.request2(
				{
					url: '/api/AppletOrder/GetGoodsShoppingCartPageList',
					data: this.msg
				},
				res => {
					this.loading = false;
					if (res.resultCode == 1) {
						uni.hideNavigationBarLoading();
						this.isloading = false;
						if (res.data.pageData.length > 0) {
							let list = res.data.pageData;
							list.forEach(x => {
								x.checked = false;
								x.GoodsList.forEach(j => {
									j.checked = false;
									j.id=j.Id;
								});
							});
							this.list = list;
						} else {
							this.list = [];
						}
					}

					uni.hideNavigationBarLoading();
				}
			);
			// this.request(
			// 	{
			// 		url: '',
			// 		header: h,
			// 		data: {
			// 			r: 'api/cart/list'
			// 		}
			// 	},

			// 	res => {
			// 		uni.hideNavigationBarLoading();
			// 		this.isloading = false;
			// 		if (res.data.list.length > 0) {
			// 			let list = res.data.list;
			// 			list.forEach(x => {
			// 				x.checked = false;
			// 				x.goods_list.forEach(j => {
			// 					j.checked = false;
			// 				});
			// 			});
			// 			this.list = list;
			// 		} else {
			// 			this.list = [];
			// 		}
			// 	}
			// );
		},

		clickcheckbox(checked, price, index, i) {
			// (item.checked, item.Price, index, i)
			if (checked == true) {
				this.checkCount += 1;
				this.TotalPrice += parseFloat((price * this.list[i].GoodsList[index].Number).toFixed(2));
				let goods_list_all = true; //判断该商场是否全选
				this.list[i].GoodsList.forEach(x => {
					if (this.editType == false) {
						//编辑的时候不判断
						if (x.checked == false && x.new_status == 0) {
							goods_list_all = false;
						}
					} else {
						if (x.checked == false) {
							goods_list_all = false;
						}
					}
				});
				if (goods_list_all == true) {
					this.list[i].checked = true;
				}
				let list_all = true; //判断所有商场是否全选
				this.list.forEach(x => {
					if (x.checked == false) {
						list_all = false;
					}
				});
				if (list_all == true) {
					this.allchecked = true;
				}
				if (this.editType == true) {
					let obj = {
						mch_id: 0,
						id: this.list[i].GoodsList[index].id
					};
					this.cart_id_list.push(obj);
				}
			} else {
				this.TotalPrice -= parseFloat((price * this.list[i].GoodsList[index].Number).toFixed(2));
				this.checkCount -= 1;
				this.allchecked = false;
				let goods_list_all = true; //判断该商场是否全选
				this.list[i].GoodsList.forEach(x => {
					if (x.checked == false) {
						goods_list_all = false;
					}
				});
				if (goods_list_all == false) {
					this.list[i].checked = false;
				}
				if (this.editType == true) {
					this.cart_id_list.forEach((x, j) => {
						if (x.id == this.list[i].GoodsList[index].id) {
							this.cart_id_list.splice(j, 1);
						}
					});
				}
			}
			this.TotalPrice = parseFloat(this.TotalPrice.toFixed(2));
		},
		mch_SelectAll(checked, i) {
			if (checked == true) {
				let add_cartlist = [];
				let new_statusnum = 0;
				this.list[i].GoodsList.forEach(x => {
					if (x.GoodsStatus == 1) {
						if (x.checked == false) {
							this.TotalPrice += parseFloat((x.Price * x.Number).toFixed(2));
							x.checked = true;
							new_statusnum++;
						}
					}

					//编辑时候的商城全选
					if (this.editType == true) {
						if (this.cart_id_list.length > 0) {
							this.cart_id_list.forEach(z => {
								if (x.id != z.id) {
									let obj = {
										mch_id: 0,
										id: x.id
									};
									add_cartlist.push(obj);
								}
							});
						} else {
							let obj = {
								mch_id: 0,
								id: x.id
							};
							add_cartlist.push(obj);
						}
					}
				});
				this.cart_id_list = this.cart_id_list.concat(add_cartlist);
				let list_all = true; //判断所有商场是否全选
				this.list.forEach(x => {
					if (x.checked == false) {
						list_all = false;
					}
				});
				if (list_all == true) {
					this.allchecked = true;
				}
				this.checkCount += new_statusnum;
			} else {
				let new_statusnum = 0;
				this.list[i].GoodsList.forEach(x => {
					if (x.GoodsStatus == 1) {
						x.checked = false;
						this.TotalPrice -= parseFloat((x.Price * x.Number).toFixed(2));

						new_statusnum++;
					}
					//编辑时候的商城全选
					this.cart_id_list.forEach((z, m) => {
						if (x.id == z.id) {
							this.cart_id_list.splice(m, 1);
						}
					});
				});
				this.allchecked = false;
				this.checkCount -= new_statusnum;
			}
			this.TotalPrice = parseFloat(this.TotalPrice.toFixed(2));
		},
		SelectAll() {
			let list = this.list;
			if (this.allchecked == true) {
				this.checkCount = 0;
				this.TotalPrice = 0;
				this.cart_id_list = [];
				list.forEach(x => {
					x.checked = true;
					x.GoodsList.forEach(j => {
						if (j.GoodsStatus == 1) {
							j.checked = true;
							this.checkCount++;
							this.TotalPrice += parseFloat((j.Price * j.Number).toFixed(2));
						}

						//编辑的时候
						if (this.editType == true) {
							this.cart_id_list.push({
								mch_id: 0,
								id: j.id
							});
						}
					});
				});
			} else {
				this.checkCount = 0;
				this.TotalPrice = 0;
				this.cart_id_list = [];
				list.forEach(x => {
					x.checked = false;
					x.GoodsList.forEach(j => {
						j.checked = false;
					});
				});
			}
			this.TotalPrice = parseFloat(this.TotalPrice.toFixed(2));
		},
		valChange(i, index, Number, p, e) {
			// (i, index, item.Number, item.Price, $event)
			let value = parseFloat(e.value);
			let price = parseFloat(p);
			if (Number > value) {
				this.list[i].GoodsList[index].Number = value;
				if (this.list[i].GoodsList[index].checked == true) {
					this.TotalPrice -= parseFloat((price * (Number - value)).toFixed(2));
				}
			} else if (value > Number) {
				this.list[i].GoodsList[index].Number = value;
				if (this.list[i].GoodsList[index].checked == true) {
					this.TotalPrice += parseFloat((price * (value - Number)).toFixed(2));
				}
			}
			this.TotalPrice = parseFloat(this.TotalPrice.toFixed(2));
		},

		edit() {
			this.editType = !this.editType;
			this.allchecked = false;
			this.TotalPrice = 0;
			this.checkCount = 0;
			this.cart_id_list = [];
			let list = this.list;
			list.forEach(x => {
				x.checked = false;
				x.GoodsList.forEach(j => {
					j.checked = false;
				});
			});
		},
		delete_btn() {
			if (this.cart_id_list.length > 0) {
				uni.showNavigationBarLoading();
				let arr=[];
				this.cart_id_list.forEach(item=>{
					arr.push(item.id);
				})
				this.request2(
					{
						url: '/api/AppletOrder/DelGoodsShoppingCartInfo',
						data: {ShoppingCartIdList:arr}
					},
					res => {
						if(res.resultCode==1){
							this.init();
							this.TotalPrice = 0;
							this.editType = false;
							this.allchecked = false;
							this.checkCount = 0;
						}
						
						uni.hideNavigationBarLoading();
					}
				);

				// this.request(
				// 	{
				// 		url: '',
				// 		method: 'POST',
				// 		header: h,
				// 		data: {
				// 			r: 'api/cart/delete',
				// 			cart_id_list: JSON.stringify(this.cart_id_list)
				// 		}
				// 	},

				// 	res => {
				// 		this.init();
				// 		this.TotalPrice = 0;
				// 		this.editType = false;
				// 		this.allchecked = false;
				// 		this.checkCount = 0;
				// 		uni.hideNavigationBarLoading();
				// 	}
				// );
			} else {
				uni.showToast({
					title: '请选择需要删除的商品',
					position: 'bottom',
					icon: 'none',
					duration: 2000
				});
			}
		},
		settlement() {
			let ShoppingCartIdList=[];
			if (this.checkCount > 0) {
				let forms = {};
				this.list.forEach(y => {
					let good = {
						// MallId: y.MallId,
						DetailList: [],
						Use_Integral: 0,
						User_Coupon_Id: 0,
						DeliveryMethod:0,
						AddressId:0,
					};
					y.GoodsList.forEach(x => {
						if (x.checked) {
							console.log("x",x)
							ShoppingCartIdList.push(x.Id)
							let g = {
								GoodsId: x.GoodsId,
								Number: x.Number,
								SpecificationSort: x.SpecificationSort,
								
							};
							good.DetailList.push(g);
						}
					});
					
					forms=good;
					console.log("forms",forms)
				});
				uni.navigateTo({
					url: '/pages/order-submit/order-submit?formData=' + encodeURIComponent(JSON.stringify(forms))+'&IsFormShoppingCart=1&ShoppingCartIdList='+JSON.stringify(ShoppingCartIdList)
				});
			} else {
				uni.showToast({
					title: '请选择购买商品',
					position: 'bottom',
					icon: 'none',
					duration: 2000
				});
			}
		},
		clickHandler(id) {
			uni.navigateTo({
				url: '/pages/goods/goods?id=' + id
			});
		}
	}
};
</script>

<style>
.cartStyle {
	height: 100%;
	position: relative;
	font-family: 'oswald';
}

.cartStyle .u-checkbox__label {
	margin-left: 12px;
}

.cartStyle .grid-text {
	font-size: 24rpx;
	margin-top: 4rpx;
	color: #939393;
}

.cartStyle .grid-text_r {
	margin-top: 4rpx;
	margin-right: 10rpx;
}

.cartStyle .cartList {
	width: 100%;
	display: flex;
	flex-direction: column;
	align-items: center;
	overflow-y: hidden;
}

.cartStyle .cartList .cartList_item {
	width: 100%;
	padding: 30rpx 30rpx 30rpx 10rpx;
	display: flex;
	flex-direction: row;
	align-items: center;
	border-bottom: 1rpx solid #f5f5f5;
}

.cartList .cartList_item .item_input {
	width: 200rpx;
	height: 60rpx;
	background: #f7f7f7;
	display: flex;
	flex-direction: row;
	align-items: center;
	justify-content: space-between;
}

.cartList .item_input .item_input_l,
.item_input_r {
	width: 50rpx;
	height: 60rpx;
	font-size: 28rpx;
	display: flex;
	align-items: center;
	justify-content: center;
}

.cartStyle .item_input .item_input_c {
	text-align: center;
	width: 50rpx;
	height: 60rpx;
	font-size: 20rpx;
}

.cartStyle .box_bottom {
	width: 100%;
	height: 50px;
	position: absolute;
	background: #fff;
	left: 0;
	bottom: 0;
	display: flex;
	flex-direction: row;
	align-items: center;
	justify-content: space-between;
	border-top: 1rpx solid #f5f5f5;
	z-index: 999;
}

.cartStyle .bottom_btn {
	display: flex;
	align-items: center;
	justify-content: center;
	width: 250rpx;
	height: 50px;
}

.cartStyle .Deletestyle {
	margin-right: 40rpx;
}
.cartStyle .invalid {
	text-align: center;
	width: 40px;
	height: 20px;
	line-height: 20px;
	border-radius: 10px;
}
</style>
